#include "rom.h"
#include <PA9.h> 
#include <fat.h>
int load_rom(char* nombre)
{
  PA_InitText(1, 0);
  PA_InitText(0, 0);
  fatInitDefault(); //Initialise fat library
  char titulo[21]="";
  int i=0;
  int prox=i;
  char a[1]="";
  FILE* romcarga=fopen(nombre,"rb");	//wb = create/truncate & write // rb Read.
  if (romcarga){
  mostrarTexto("ROM ABIERTA",2,0);
  }else{
  mostrarTexto("ERROR",2,0);
  }
  int hilow=checksum(nombre);
  fpos_t posbin[2];
  posbin[0]=65984;
  posbin[1]=32704;
  if(!fsetpos(romcarga, &posbin[hilow])==0)
  {
  mostrarTexto("ERROR",2,0);
  }
  fread(&titulo,sizeof(char),21,romcarga);
  vaciador();
  mostrarTexto("TITULO DE LA ROM: ",1,0);
  mostrarTexto(titulo,0,21);
  vaciador();
  fread(a,sizeof(char),1,romcarga);
  prox=(int)a[0];
  mostrarTexto("Velocidad y Tipo de Rom",1,0);
  int speed=prox/16;
  vaciador();
  if (prox%16>2){
  mostrarTexto("Hi Rom",0,0);
  }else{
  mostrarTexto("Low Rom",0,0);
  }
  if (speed>2){
  mostrarTexto("Fast-Rom",0,0);
  }else{
  mostrarTexto("Slow-Rom",0,0);
  }
  fread(a,sizeof(char),1,romcarga);
  prox=(int)a[0];
  vaciador();
  mostrarTexto("TIPO DE CARTUCHO: ",1,0);
  switch(prox){
	case 0:	mostrarTexto("ROM",0,0);
			break;
	case 1:	mostrarTexto("ROM/RAM",0,0);
			break;
	case 2:	mostrarTexto("ROM/SRAM",0,0);
			break;
	case 3:	mostrarTexto("ROM/DSP1",0,0);
			break;
	case 4:	mostrarTexto("ROM/DSP1/RAM",0,0);
			break;
	case 5:	mostrarTexto("ROM/DSP1/SRAM",0,0);
			break;
	case 6:	mostrarTexto("FX",0,0);
			break;
	case 53:mostrarTexto("KIRBYYY!!",0,0);
			break;
	default:mostrarTexto("Otro Tipo",0,0);
  }
  fread(a,sizeof(char),1,romcarga);
  prox=(int)a[0];
  vaciador();
  mostrarTexto("TAMAO DEL CARTUCHO: ",1,0);
  switch(prox){
	case 8:	mostrarTexto("2 Mbits / 256 KBytes",0,0);
			break;
	case 9:	mostrarTexto("4 Mbits / 512 KBytes",0,0);
			break;
	case 10:mostrarTexto("8 Mbits / 1 MByte",0,0);
			break;
	case 11:mostrarTexto("16 Mbits / 2 MBytes",0,0);
			break;
	case 12:mostrarTexto("32 Mbits / 4 MBytes",0,0);
			break;
  }
  
  fread(a,sizeof(char),1,romcarga);
  prox=(int)a[0];
  vaciador();
  mostrarTexto("TAMAO DE LA SRAM: ",1,0);
  switch(prox){
	case 0:	mostrarTexto("Sin SRAM",0,0);
			break;
	case 1:	mostrarTexto("16 Kbits / 2 KBytes",0,0);
			break;
	case 2:mostrarTexto("32 Kbits / 4 KBytes",0,0);
			break;
	case 3:mostrarTexto("64 Kbits / 8 KBytes",0,0);
			break;
  }
  
  fread(a,sizeof(char),1,romcarga);
  prox=(int)a[0];
  vaciador();
  mostrarTexto("PAIS: ",1,0);
  switch(prox){
	case 0:	mostrarTexto("Japon (NTSC)",0,0);
			break;
	case 1:	mostrarTexto("USA (NTSC)",0,0);
			break;
	case 2:mostrarTexto("EUROPA/OCEANIA/ASIA (PAL)",0,0);
			break;
	case 3:mostrarTexto("SUECIA (PAL)",0,0);
			break;
	case 4:mostrarTexto("FINLANDIA (PAL)",0,0);
			break;
	case 5:mostrarTexto("DINAMARCA (PAL)",0,0);
			break;
	case 6:mostrarTexto("FRANCIA (PAL)",0,0);
			break;
	case 7:mostrarTexto("HOLANDA (PAL)",0,0);
			break;
	case 8:mostrarTexto("ESPAA (PAL)",0,0);
			break;
	case 9:mostrarTexto("ALEMANIA/AUSTRIA/SUIZA (PAL)",0,0);
			break;
	case 10:mostrarTexto("ITALIA",0,0);
			break;
	case 11:mostrarTexto("HONG KONG/CHINA (PAL)",0,0);
			break;
	case 12:mostrarTexto("INDONESIA (PAL)",0,0);
			break;
	case 13:mostrarTexto("KOREA (PAL)",0,0);
			break;
  }
  
   fread(a,sizeof(char),1,romcarga);
  prox=(int)a[0];
  vaciador();
  mostrarTexto("LICENCIA: ",1,0);
  switch(prox){
	case 0:	mostrarTexto("Invalida",0,0);
			break;
	case 1:	mostrarTexto("Nintendo",0,0);
			break;
	case 5:mostrarTexto("Zamuse",0,0);
			break;
	case 8:mostrarTexto("Capcom",0,0);
			break;
  }
  
  fread(a,sizeof(char),1,romcarga);
  prox=(int)a[0];
  vaciador();
  for (i=0;i<4;i++){
  fread(a,sizeof(char),1,romcarga);
  }
  
  fclose(romcarga);								//Cerramos la lectura
  return 0;
}





void mostrarTexto(char* a,int s,int tam)
{
  int j=0;
  int longitud=tam;
  if (longitud==0){
  while (a[longitud]!=0)
  {
  longitud++;
  }
  }
  while (j<longitud)
  {
  PA_WaitForVBL() ;
  PA_WaitForVBL() ;
  PA_WaitForVBL() ;
  PA_WaitForVBL() ;
  PA_WaitForVBL() ;
  j++;
  if (Stylus.Held)
  {
  j=longitud;
  }
  if (s!=2)
  {
  PA_BoxText (s,6,6,24,18, a , j) ;
  }else{
  PA_BoxText (0,6,6,24,18, a , j) ;
  PA_BoxText (1,6,6,24,18, a , j) ;
  }
  }
  blinkA();

}
void blinkA()
{
int i=0;
while (!Pad.Newpress.A)
	{
		if(i==100)
		{
		i=0;
		}
		if (i==0)
		{
		PA_OutputSimpleText(1, 30, 18, "A");
		}
		if (i==50)
		{
		PA_OutputSimpleText(1, 30, 18, " ");
		}
		i++;
		PA_WaitForVBL();
	}
PA_OutputSimpleText(1, 30, 18, " ");
}

int checksum(char* nombre){

  int checksum[4];
  char check[1]="";
  FILE* romcarga = fopen(nombre,"rb");
  fpos_t checkhi=66012;
  fsetpos(romcarga, &checkhi);
  fread(&check,sizeof(char),1,romcarga);
  checksum[0]=(int)check[0];
  fread(&check,sizeof(char),1,romcarga);
  checksum[1]=(int)check[0];
  fread(&check,sizeof(char),1,romcarga);
  checksum[2]=(int)check[0];
  fread(&check,sizeof(char),1,romcarga);
  checksum[3]=(int)check[0];
  if((checksum[0]|checksum[2])==255){
	if((checksum[1]|checksum[3])==255){
	mostrarTexto("CheckSum OK, HIROM",2,0);
	return 0;
	}
	}

  fpos_t checklow=32732;
  fsetpos(romcarga, &checklow);
  fread(&check,sizeof(char),1,romcarga);
  checksum[0]=(int)check[0];
  fread(&check,sizeof(char),1,romcarga);
  checksum[1]=(int)check[0];
  fread(&check,sizeof(char),1,romcarga);
  checksum[2]=(int)check[0];
  fread(&check,sizeof(char),1,romcarga);
  checksum[3]=(int)check[0];
    if((checksum[0]|checksum[2])==255){
	if((checksum[1]|checksum[3])==255){
	mostrarTexto("CheckSum OK, LOROM",2,0);
	return 1;
	}
	}
mostrarTexto("CheckSum FALLIDO, Asignando LOROM",2,0);
//return 1;
return 0; //Solo para debugging, ACORDARME DE QUITARLO!!

}

void vaciador()
{
PA_ClearTextBg(0);
       PA_ClearTextBg(1);
    PA_ResetBg(0);
    PA_ResetBg(1);
    PA_ResetBgSys();
    PA_ResetSpriteSys();
    PA_InitText(0,0);
    PA_InitText(1,0);
} 

